# Airpay Flutter

Airpay Flutter plugin for payment integeration.


## Usage
Add `airpay_package` as a [dependency in your pubspec.yaml file](https://flutter.io/platform-plugins/).

You can now include a airpayPackage in your project. See the
[airpayPackage](https://pub.dev/packages/airpay_package/)
widget's Dartdoc for more details on how to use the widget.

## Installation

This plugin is available on Pub: [https://pub.dev/packages/](https://pub.dev/my-packages)

Add this to `dependencies` in your app's `pubspec.yaml`

```yaml
airpay_emar_package: ^1.0.0
```

Just make sure that your activity has set windowSoftInputMode to adjustResize in AndroidManifest.xml

<application>
    <activity android:windowSoftInputMode="adjustResize">
    </activity>
</application >


## Android apps must declare their use of the internet in the Android manifest (AndroidManifest.xml ):

In the AndroidManifest.xml file located at android/app/src/main you need to add this permission inside the manifest tag.

 <uses-permission android:name="android.permission.INTERNET" />

**Note**: For android make sure that the minimum API level for your app is 19 or higher.

## Usage

- Learn about the <a href="https://www.airpay.co.in/" target="_blank">Airpay Payment</a>.
 - Sign up <a href="https://www.airpay.co.in/services/subscription">Airpay Account</a> and generate the API Keys from the Airpay platform. Using the sandbox keys helps simulate a sandbox environment. No actual monetary transaction happens when using the sandbox keys. Use Live keys once you have thoroughly tested the application and are ready to go live.
 

