import 'dart:convert';
import 'dart:math';
import 'package:crypto/crypto.dart';
import 'package:encrypt/encrypt.dart' as encrypt;

void main(){

  var secret = "hgrTsTTUrH7xvRN9";
  Map<String, dynamic> jsonParams = {
    'privatekey': "436b6dd20f694d9eb86b9605f17ffead9fce6b8036110d8fd95a6be8a7797af4",
    'orderid':  "10",
    'mercid': "247033",
    'checksum': "eb9357a82ad0d1bad864c9084c9be8be",
    'datetime': "17/07/2023 15:53:17",
  };

  var encrypt_request = encrypt256Str(jsonParams.toString(),"hgrTsTTUrH7xvRN9");

  print("enc ->"+encrypt_request);
  print("dec -->"+decrypt256Str(encrypt_request, "hgrTsTTUrH7xvRN9"));

}
String generate16DigitNumber() {
  Random random = Random();
  String number = '';
  for (int i = 0; i < 16; i++) {
    number += random.nextInt(10).toString();
  }
  return number;
}

String encrypt256Str(String plainText, String secretKey){

  var generatedIV = generate16DigitNumber();

  var secretkey_md5 = md5.convert(utf8.encode(secretKey));

  final key = encrypt.Key.fromUtf8(secretkey_md5.toString()); //32
  final iv = encrypt.IV.fromUtf8(generatedIV);
  final encrypter = encrypt.Encrypter(encrypt.AES(key,mode:encrypt.AESMode.cbc));

  final encrypted = encrypter.encrypt(plainText, iv: iv);
  //  final decrypted = encrypter.decrypt(encrypted, iv: iv);
  print("iv -->"+generatedIV);
  print("encrypted base64 -->"+encrypted.base64);

  return generatedIV + encrypted.base64;
}

String decrypt256Str(String fullResponse, String secretKey){
  //fullResponse.split("|");
  String ivFromResponse = fullResponse.substring(0, 16);
  String encryptedResponse = fullResponse.substring(16);
  //String ivFromResponse = fullResponse.split("|")[0];
  //String encryptedResponse = fullResponse.split("|")[1];
  print(ivFromResponse);
  print(encryptedResponse);

  var secretkey_md5 = md5.convert(utf8.encode(secretKey));

  final key = encrypt.Key.fromUtf8(secretkey_md5.toString());
  final iv = encrypt.IV.fromUtf8(ivFromResponse);
  //final encrypter = encrypt.Encrypter(encrypt.AES(key,mode:encrypt.AESMode.cbc));
  final encrypter = encrypt.Encrypter(encrypt.AES(key, mode: encrypt.AESMode.cbc)); //, padding: 'PKCS7'


  final encrypted = encrypt.Encrypted.fromBase64(encryptedResponse);
  final decrypted = encrypter.decrypt(encrypted, iv: iv);

  print("Decrypted Response => $decrypted");
  return decrypted;
}

